"use strict";
exports.__esModule = true;
var Is = /** @class */ (function () {
    function Is() {
    }
    Is.callToString = function (arg) {
        return Object.prototype.toString.call(arg);
    };
    Is.$string = function (arg) {
        return Is.callToString(arg) === '[object String]';
    };
    Is.is = function (arg, type) {
        if (Is.$function(type)) {
            return arg instanceof type;
        }
        if (Is.$string(type)) {
            return Is.callToString(arg) === "[object " + type + "]";
        }
        return arg === type;
    };
    Is.$array = function (arg) {
        return Is.is(arg, 'Array');
    };
    Is.$null = function (arg) {
        return Is.is(arg, 'Null');
    };
    Is.$number = function (arg) {
        return Is.is(arg, 'Number');
    };
    Is.$object = function (arg) {
        return Is.is(arg, 'Object');
    };
    Is.$undefined = function (arg) {
        return Is.is(arg, 'Undefined');
    };
    Is.$boolean = function (arg) {
        return Is.is(arg, 'Boolean');
    };
    Is.$function = function (arg) {
        return Is.callToString(arg) === '[object Function]';
    };
    Is.objectIsValid = function (data, rules) {
        if (!Is.$object(data))
            throw new Error('The data parameter must be an Object');
        if (!Is.$object(rules))
            throw new Error('The rules parameter must be an Object');
        var $response = true;
        var $keys = Object.getOwnPropertyNames(rules);
        $keys.forEach(function (key) {
            var rule = rules[key];
            if (Is.$array(rule)) {
                if (rule.length < 1)
                    return;
                var parcial_1 = false;
                rule.forEach(function (_rule) {
                    parcial_1 = parcial_1 || Is.is(data[key], _rule);
                });
                return $response = $response && parcial_1;
            }
            $response = $response && Is.is(data[key], rule);
        });
        return $response;
    };
    Is.$numeric = function (arg) {
        if (Is.$number(arg)) {
            return true;
        }
        var $arg = String(arg || '');
        var regex = /^[-+]?(([0-9]+)|([0-9]*(\.[0-9]+))|([0-9]+\.))([Ee]([-+]?[0-9]+))?$/g;
        return regex.test($arg);
    };
    Is.$primitive = function (arg) {
        var validations = [
            Is.$undefined,
            Is.$null,
            Is.$boolean,
            Is.$number,
            Is.$string,
            function (arg) { return Is.is(arg, 'Symbol'); }
        ];
        return validations.some(function (item) { return item(arg); });
    };
    Is.$empty = function (arg) {
        var validations = [
            Is.$undefined,
            Is.$null,
            function (arg) { return Is.$boolean(arg) && !arg; },
            function (arg) { return Is.$number(arg) && arg === 0; },
            function (arg) { return (Is.$array(arg) || Is.$string(arg)) && (arg === "0" || arg.length === 0); }
        ];
        return validations.some(function (item) { return item(arg); });
    };
    return Is;
}());
exports["default"] = Is;
